# Auto-elevazione: se lo script non è eseguito con privilegi amministrativi, lo riavvia in modalità elevata.
if (-not ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator"))
{
    Write-Output "Riavvio dello script in modalità amministratore..."
    Start-Process powershell -Verb runAs -ArgumentList "-NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`""
    exit
}

try {
    Write-Output "Inizio configurazione della lingua italiana (it-IT)..."

    # Imposta la lista delle lingue utente
    Write-Output "Impostazione della lista delle lingue utente..."
    $LangList = New-WinUserLanguageList it-IT
    Set-WinUserLanguageList $LangList -Force

    # Imposta l'override della lingua dell'interfaccia utente
    Write-Output "Impostazione dell'override della lingua dell'interfaccia utente..."
    Set-WinUILanguageOverride -Language it-IT

    # Imposta la localizzazione di sistema
    Write-Output "Impostazione della localizzazione di sistema..."
    Set-WinSystemLocale it-IT

    # Imposta la cultura corrente (questo modifica la formattazione di data, ora, numeri, ecc.)
    Write-Output "Impostazione della cultura corrente..."
    Set-Culture it-IT

    Write-Output "Verifica delle impostazioni correnti..."

    $UserLangList = Get-WinUserLanguageList
    $UILangOverride = (Get-WinUILanguageOverride)
    $SystemLocale = (Get-WinSystemLocale)
    $Culture = (Get-Culture)

    Write-Output "Lista lingue utente: $($UserLangList | ForEach-Object { $_.LanguageTag } | Out-String)"
    Write-Output "Override lingua UI: $UILangOverride"
    Write-Output "Locale di sistema: $SystemLocale"
    Write-Output "Cultura corrente: $Culture"

    Write-Output "Operazione completata. Riavvia il computer per applicare completamente le modifiche."
}
catch {
    Write-Output "Si è verificato un errore: $_"
}

# Aggiunge una pausa per evitare la chiusura immediata della finestra (utile se lo script viene eseguito con doppio clic)
Read-Host -Prompt "Premere Invio per uscire"